var applet = RSEnableRemoteScripting("./");
var serverURL = "http://realtime.juniornet.net/cgi-bin/donkey/swdonkey.cgi";

var gTitle = 0;
var gBody = 1;
var gUser = 2;
var gSubjectID = 3;
var gThreadID = 4;
var gPostID = 5;

// function GetEntry(content_type, subtype, key) {
function GetEntry() {
    var params = GetParams(GetEntry.arguments);
    var remote = RSExecuteParams(serverURL, "GetEntry", params);
    if (remote.status == RS_OK) {
	return remote.data;
    }

    return "";
}

// function GetEntryTest(content_type, subtype, key) {
function GetEntryTest() {
    var params = GetParams(GetEntryTest.arguments);
    var remote = RSExecuteParams(serverURL, "GetEntryTest", params);
    if (remote.status == RS_OK) {
	return remote.data;
    }

    return "";
}

// function AddSubject(content_type, title, body, user) {
function AddSubject() {
    var params = GetParams(AddSubject.arguments);
    var remote = RSExecuteParams(serverURL, "AddSubject", params);
    if (remote.status == RS_OK) {
	return remote.data;
    }

    return "";
}

// function AddThread(subject_id, content_type, title, body, user) {
function AddThread() {
    var params = GetParams(AddThread.arguments);
    var remote = RSExecuteParams(serverURL, "AddThread", params);
    if (remote.status == RS_OK) {
	return remote.data;
    }

    return "";
}

// function AddPost(subject_id, thread_id, content_type, title, body, user) {
function AddPost() {
    var params = GetParams(AddPost.arguments);
    var remote = RSExecuteParams(serverURL, "AddPost", params);
    if (remote.status == RS_OK) {
	return remote.data;
    }

    return "";
}

// function ApproveSubject(content_type, title, body, user) {
function ApproveSubject() {
    var params = GetParams(ApproveSubject.arguments);
    // tack the approver onto the end
    params[params.length] = "JuniorNet";
    var remote = RSExecuteParams(serverURL, "ApproveSubject", params);
    if (remote.status == RS_OK) {
	return remote.data;
    }

    return "";
}

// function ApproveThread(subject_id, content_type, title, body, user) {
function ApproveThread() {
    var params = GetParams(ApproveThread.arguments);
    params[params.length] = "JuniorNet";
    var remote = RSExecuteParams(serverURL, "ApproveThread", params);
    if (remote.status == RS_OK) {
	return remote.data;
    }

    return "";
}

// function ApprovePost(subject_id, thread_id, content_type, title, body, user) {
function ApprovePost() {
    var params = GetParams(ApprovePost.arguments);
    params[params.length] = "JuniorNet";
    var remote = RSExecuteParams(serverURL, "ApprovePost", params);
    if (remote.status == RS_OK) {
	return remote.data;
    }

    return "";
}

var recordSeparator = String.fromCharCode(17);
var fieldSeparator = String.fromCharCode(18);

// function GetSubjectsList(content_type, order) {
function GetSubjectsList() {
    var params = GetParams(GetSubjectsList.arguments);
    var remote = RSExecuteParams(serverURL, "GetSubjectsList", params);
    if (remote.status == RS_OK) {
	var data = remote.data;
	var list = data.split(recordSeparator);
	for (i = 0; i < list.length; i++) {
	    list[i] = list[i].split(fieldSeparator);
	}
	return list;
    }

    return "";
}

// function GetThreadsList(content_type, subject_id, order) {
function GetThreadsList() {
    var params = GetParams(GetThreadsList.arguments);
    var remote = RSExecuteParams(serverURL, "GetThreadsList", params);
    if (remote.status == RS_OK) {
	var data = remote.data;
	var list = data.split(recordSeparator);
	for (i = 0; i < list.length; i++) {
	    list[i] = list[i].split(fieldSeparator);
	}
	return list;
    }

    return "";
}

// function GetThreadsItem(content_type, subject_id, thread_id) {
function GetThreadItem() {
    var params = GetParams(GetThreadItem.arguments);
    var remote = RSExecuteParams(serverURL, "GetThreadItem", params);
    if (remote.status == RS_OK) {
	var data = remote.data;
	var list = data.split(recordSeparator);
	list = list[0].split(fieldSeparator);
	return list;
    }

    return "";
}

// function GetPostsList(content_type, subject_id, thread_id, order) {
function GetPostsList() {
    var params = GetParams(GetPostsList.arguments);
    var remote = RSExecuteParams(serverURL, "GetPostsList", params);
    if (remote.status == RS_OK) {
	var data = remote.data;
	var list = data.split(recordSeparator);
	for (i = 0; i < list.length; i++) {
	    list[i] = list[i].split(fieldSeparator);
	}
	return list;
    }

    return "";
}

// function SubmitResponse(content_type, user, response) {
function SubmitResponse() {
    var params = GetParams(SubmitResponse.arguments);
    var remote = RSExecuteParams(serverURL, "SubmitResponse", params);
    if (remote.status == RS_OK) {
	return remote.data;
    }

    return "";
}

// function AddVote(content_type, poll_id, choice_id, comment, user) {
function AddVote() {
    var params = GetParams(AddVote.arguments);
    var remote = RSExecuteParams(serverURL, "AddVote", params);
    if (remote.status == RS_OK) {
	return remote.data;
    }

    return "";
}

// function GetResultsByTotal(content_type, poll_id) {
function GetResultsByTotal() {
    var params = GetParams(GetResultsByTotal.arguments);
    var remote = RSExecuteParams(serverURL, "GetResultsByTotal", params);
    if (remote.status == RS_OK) {
	return remote.data;
    }

    return "";
}

// function GetChoiceComments(content_type, poll_id, choice_id) {
function GetChoiceComments() {
    var params = GetParams(GetChoiceComments.arguments);
    var remote = RSExecuteParams(serverURL, "GetChoiceComments", params);
    if (remote.status == RS_OK) {
	return remote.data;
    }

    return "";
}

// function GetChoiceNames(content_type, poll_id) {
function GetChoiceNames() {
    var params = GetParams(GetChoiceNames.arguments);
    var remote = RSExecuteParams(serverURL, "GetChoiceNames", params);
    if (remote.status == RS_OK) {
	return remote.data;
    }

    return "";
}

// function SubmitScore(content_type, user, score) {
function SubmitScore() {
    var params = GetParams(SubmitScore.arguments);
    var remote = RSExecuteParams(serverURL, "SubmitScore", params);
    if (remote.status == RS_OK) {
	return remote.data;
    }

    return "";
}

// function GetScore(content_type, length, date) {
function GetScore() {
    var params = GetParams(GetScore.arguments);
    var remote = RSExecuteParams(serverURL, "GetScores", params);
    if (remote.status == RS_OK) {
	return remote.data;
    }

    return "";
}

// function GetTodayScores(content_type, length) {
function GetTodayScores() {
    var params = GetParams(GetTodayScores.arguments);
    var remote = RSExecuteParams(serverURL, "GetTodayScores", params);
    if (remote.status == RS_OK) {
	return remote.data;
    }

    return "";
}
